package com.wedoogift.transaction.entity;

import java.math.BigDecimal;
import java.util.Date;

import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBAttribute;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBAutoGeneratedKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBHashKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBTable;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBTypeConvertedEnum;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBVersionAttribute;
import com.wdoogift.deposite.api.utils.DepositeTypeEnum;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.NoArgsConstructor;
import lombok.Setter;
import software.amazon.awssdk.enhanced.dynamodb.mapper.annotations.DynamoDbSecondaryPartitionKey;
import software.amazon.awssdk.enhanced.dynamodb.mapper.annotations.DynamoDbSecondarySortKey;

@Setter
@DynamoDBTable(tableName = "deposite")
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Deposite {

  private String id;

  private String codeEmployee;

  private String codeCompany;

  private DepositeTypeEnum giftType;

  private BigDecimal prize;

  private boolean active;

  private Date startDeposite;

  private Date endDeposite;

  private Long version;

  @DynamoDBHashKey(attributeName = "Id")
  @DynamoDBAutoGeneratedKey
  public String getId() {
    return id;
  }

  @DynamoDbSecondaryPartitionKey(indexNames = "deposite_by_employee")
  @DynamoDBAttribute
  public String getCodeEmployee() {
    return codeEmployee;
  }

  @DynamoDBAttribute
  public String getCodeCompany() {
    return codeCompany;
  }

  @DynamoDBTypeConvertedEnum
  @DynamoDBAttribute
  public DepositeTypeEnum getGiftType() {
    return giftType;
  }

  @DynamoDBAttribute
  public BigDecimal getPrize() {
    return prize;
  }

  @DynamoDBAttribute
  public boolean isActive() {
    return active;
  }

  @DynamoDbSecondarySortKey(indexNames = {"deposite_by_star", "deposite_by_employee"})
  @DynamoDBAttribute
  public Date getStartDeposite() {
    return startDeposite;
  }

  @DynamoDbSecondarySortKey(indexNames = {"deposite_by_end", "deposite_by_employee"})
  @DynamoDBAttribute
  public Date getEndDeposite() {
    return endDeposite;
  }

  @DynamoDBVersionAttribute
  public Long getVersion() {
    return version;
  }
}
